
===============================================================
aflr4 RELEASE NOTES: 10/02/25 RELEASE VERSION 11.9.10
===============================================================

Enhancements/ Additions:
------------------------

* Revised default value for er_lim to prevent over refinement and
  for compatibility with previous versions of AFLR4.

* Added creation of a aflr4_all in static and dynamic modes.
  All code used by AFLR4 is included in aflr4_all except for
  EGADS code that requires the egads lib.

* Added aflr4_i alternative code with APIs intended to be used
  as a guide for integration of AFLR4 within another system.
  aflr4_i uses the aflr4_all combined lib and simplified data
  types

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 05/21/25 RELEASE VERSION 11.9.4
===============================================================

Enhancements/ Additions:
------------------------

* Added back the min_scale input parameter and revised curvature 
  processes so that minimum spacing can be limited. It is only
  needed for cases with poorly defined geometry. If a given case
  fails on meshing a given surface/face entity then using a value
  of min_scale=0.005 may allow a surface mesh to be generated.
  Using min_scale=0 will allow the surface curvature to determine
  the minimum spacing based on the curv_angle and geometry
  evaluation tolerance (from CAD geometry data).

* Added options for generating surface definition meshes,
  mw_surf_def and nw_surf_def, for use with CAD definitions
  when the surface definition is in question.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.

===============================================================
aflr4 RELEASE NOTES: 11/27/24 RELEASE VERSION 11.8.4
===============================================================

Enhancements/ Additions:
------------------------

* Revised curvature refinement input parameters.
  The curvature factor curv_factor has been replaced by the
  curvature angle curv_angle as it is far easier to control.

* Removed min_scale input parameters and revised curvature 
  processes so that spacing is set by curvature without the
  lower limit that was imposed by min_scale.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.

===============================================================
aflr4 RELEASE NOTES: 10/28/24 RELEASE VERSION 11.7.9
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.26.

* Added option to compile for use with EGADS Lite. However,
  the only way to read an EGADS input file with EGADS Lite is
  to use a file containing a binary stream created by
  EG_exportModel which is not available within AFLR4 at
  present.

* Changed API for aflr4_main_vizir to aflr4_main_i for use
  with aflr4_i.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 10/08/24 RELEASE VERSION 11.6.3
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.25.

* Added option to minimize geometry related output.

* Added option to skip EGADS tess generation data at completion.

* Added option to minimize surface mesh generation related output.

* Added routine to save and get surface mesh spacing data.

* Modified API for integration of aflr4_main_vizir.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 07/19/24 RELEASE VERSION 11.5.15
===============================================================

Enhancements/ Additions:
------------------------

* Modified check to turn off auto mode for curvature refinement
  and proximity checking if the complete starting surface mesh
  is too coarse. The previous check turned off auto mode if the
  starting surface mesh for any individual face definition was
  too coarse.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 04/18/24 RELEASE VERSION 11.5.14
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.24.

* Added multi-zone capability for matching edges that differ in
  defined direction.

* Added check to turn off auto mode for curvature refinement if
  the starting surface mesh is too coarse.

Bugs Fixed:
-----------

* Revised all EGADS loop related maps to account for special
  case duplicated loops with a face-loop sense of +/-2.

* Corrected EGADS loop direction sense for special case
  duplicated loops with a face-loop sense of +/-2.

* Corrected an EGADS memory allocation issue.

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 10/31/23 RELEASE VERSION 11.5.10
===============================================================

Enhancements/ Additions:
------------------------

* Added multi-zone capability for cases with multiple bodies
  and matching faces with curvature.

Bugs Fixed:
-----------

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 06/26/23 RELEASE VERSION 11.5.6
===============================================================

Enhancements/ Additions:
------------------------

* Added multi-zone capability for cases with multiple bodies
  and matching faces.

Bugs Fixed:
-----------

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 04/20/23 RELEASE VERSION 11.4.5
===============================================================

Enhancements/ Additions:
------------------------

* Initial implementation of multi-zone capability.
  To be completed in the near future.

* Added option for configurations with a structural skin topology. 
  Using either "-skin" or "skin_mode=1" option will active skin mode.
  This option will ignore the specified Grid BC values and treat each
  surface as a transparent surface that can be topologically open.
  By default the input configuration is assumed to be closed with all
  solid surfaces forming one or more bodies that may have internal
  transparent surface. Note that this option will produce a surface
  mesh that is not compatible with AFLR3 volume mesh generator. 

Bugs Fixed:
-----------

* Fixed bug in conversion of trias to quads routine ug3_triaq.

* Fixed bugs with parallel mode code.

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
aflr4 RELEASE NOTES: 03/28/23 RELEASE VERSION 11.3.18
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.23.

Bugs Fixed:
-----------


===============================================================
aflr4 RELEASE NOTES: 03/03/23 RELEASE VERSION 11.3.17
===============================================================

Enhancements/ Additions:
------------------------

* Added AFLR4 input parameter for local quad-face combination/mesh
  generation flag.

Bugs Fixed:
-----------

===============================================================
aflr4 RELEASE NOTES: 11/29/22 RELEASE VERSION 11.3.12
===============================================================

Enhancements/ Additions:
------------------------

* Changed all sprintf calls to snprintf.

Bugs Fixed:
-----------

===============================================================
aflr4 RELEASE NOTES: 11/18/22 RELEASE VERSION 11.3.8
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for quad dominant surface meshing. This
  capability can be invoked globally or by individual Faces
  using EGADS attributes or command line flags (see -quad).

Bugs Fixed:
-----------

===============================================================
aflr4 RELEASE NOTES: 08/04/22 RELEASE VERSION 11.2.3
===============================================================

Enhancements/ Additions:
------------------------

* Replaced all surface generation routines and updated internal
  structures for compatibility with anisotropic meshing and
  related libraries. The capability to actually generate an
  anisotropic surface mesh is in progress. The current routines
  will produce the same (or similar) mesh to previous versions
  of AFLR4.

Bugs Fixed:
-----------

===============================================================
aflr4 RELEASE NOTES: 07/14/22 RELEASE VERSION 10.22.23
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.21.

* Changes for compatibility with AFLR43.

* Full capability for generating an EGADS tessellation with
  proper linkage to Faces and Edges from AFLR3 generated volume
  meshes along with complete integration with AFLR3.

* Added capability in tess creation for singular points where
  three or more internal or periodic edges intersect.

Bugs Fixed:
-----------

* Fixed issue in tess creation with periodic edges.

===============================================================
aflr4 RELEASE NOTES: 12/12/21 RELEASE VERSION 10.19.12
===============================================================

Enhancements/ Additions:
------------------------

* Capability for generating an EGADS tessellation with proper
  linkage to Faces and Edges from AFLR3 generated volume
  meshes. Including multi-use edges and multi-use nodes.

* Modified use of the global scale factor, sf_global.

* Changes for interactive use.

* Added internal variable for reference length, ref_len_, to
  store the input or computed reference length, ref_len.

* Added an optional interactive test mode to the main program.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 09/14/21 RELEASE VERSION 10.17.7
===============================================================

Enhancements/ Additions:
------------------------

* Update to EGADS 1.20.

* Changes for saving edge grid connectivity and ID.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/02/21 RELEASE VERSION 10.16.1
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for EGADS Loops that contain duplicate Edges.

* Modified EGADS tess creation and setting.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 05/25/21 RELEASE VERSION 10.15.9
===============================================================

Enhancements/ Additions:
------------------------

* Update to EGADS 1.18.

* Added capability for EGADS effective surface definitions.

* Added input parameter flags -comp_ids and -comp_set_list to
  specify discrete or CAD effective/composite surface definitions.

* Added capability to edit the input surface definition with
  surface definitions specified to either keep or remove.

* Added input parameter flags -keep_ids and -rm_ids for editing
  the input surface definition.

* Added input parameter flag mclosed to allow the input definition
  to be open. By default a closed definition is required.

* Restored API for aflr4_set_ext_cad_data to original form with
  only the CAD model as input.

* Modified the process for creating and evaluating an EGADS Tess from
  the output surface mesh generated by AFLR4.

* Removed check_tess argument from API for egads_aflr4_get_tess.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 02/11/21 RELEASE VERSION 10.13.7
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with UG library routines and parameter
  initialization.

* Added edge scale factor capability for EGADS CAD geometry
  definitions. The edge scale factor is set by the EGADS data
  file attribute AFLR4_Edge_Scale_Factor. If set for a given
  edge then the edge mesh spacing is scaled but the scale factor
  on the given edge.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 12/08/20 RELEASE VERSION 10.12.1
===============================================================

Enhancements/ Additions:
------------------------

* Internal changes for integration in interactive systems.

* Added library aflr4_main for all main program related routines.
  To compile library aflr4_main along the version v1.86 dated
  9 October 2020 or later is required.

* All routines in src/aflr4/main have changed names to
  aflr4_main_* (some old, some new) and are included in library
  aflr4_main. See aflr4.c for current usage.

* Changed name for number of TEST MODE overall repeat execution
  passes from Number_of_Calls to n_test_mode_overall_passes.

* Minor revisions in documentation.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 09/22/20 RELEASE VERSION 10.9.5
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised DGEOM library.

* Revisions for interactive use in other systems.

* Added automatic setting of the DGEOM data structure grid BC
  flag from the DGEOM definition structure values.

* Separated out farfield add-on and auto BC setting options
  from initial geometry setup.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 08/23/20 RELEASE VERSION 10.8.7
===============================================================

Enhancements/ Additions:
------------------------

* Added parameters mier_ids and mier_list to control isolated
  edge refinement for individual surface definitions.

* Added isolated edge refinement flag to DGEOM surface definition
  data structure.

* Added EGADS attributes to control the isolated edge refinement.
  The EGADS attributes are AFLR4_mier (global isolated edge
  refinement flag) and AFLR4_Isolated_Edge_Refinement_Flag
  (individual surface isolated edge refinement flag).

* Revised rank and description of some input parameters in
  aflr4_initialize_param.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 08/12/20 RELEASE VERSION 10.7.12
===============================================================

Enhancements/ Additions:
------------------------

* Added parameter Number_of_iCalls for testing interactive use.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 08/04/20 RELEASE VERSION 10.7.7
===============================================================

Enhancements/ Additions:
------------------------

* Modified setting of EGADS attributes.

* Added setting of all attributes to the output EGADS geometry
  file.

* Additional revisions to how surface definition data is stored
  and retrieved.

* Changed parameter name of global surface mesh spacing scale
  factor from sf_all to sf_global. The name sf_all is still
  supported as an alternative name for sf_global.

* Changed flag name of global edge refinement flag from
  -mer_all to -er_all. The flag -mer_all is no longer valid.
  Using the flag -er_all has the same effect, and still sets
  mer_all=1. The parameter name mer_all which is be set using
  mer_all=0 or mer_all=1 is still valid.

* Added automatic setting of transparent grid BC if a surface
  has a free edge.

* Added option to automatically set the farfield grid BC on the
  outermost closed body by setting the parameter option
  auto_set_ff_bc (which is on by default).

* Added setting of all parameters used for automatic spacing
  to the output argument file, case_name.aflr4.arg. An additional
  argument file, case_name.inp.aflr4.arg is also output and
  contains only the arguments set via the command line. It is
  the same as the argument file output by previous versions of
  AFLR4.

Bugs Fixed:
-----------

* Corrected an issue determine edge-face and face neighbor maps
  with CAD geometry.

* Corrected farfield spacing calculation.

===============================================================
aflr4 RELEASE NOTES: 07/10/20 RELEASE VERSION 10.6.7
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised DGEOM library.

* Added setup of DGEOM data structure for global parameters
  within EGADS_AFLR4 library.

* Revised substantially how surface definition data is stored
  and retrieved.

* Revised main program.

Bugs Fixed:
-----------

* Corrected and simplified farfield spacing calculation.

===============================================================
aflr4 RELEASE NOTES: 06/13/20 RELEASE VERSION 10.5.3
===============================================================

Enhancements/ Additions:
------------------------

* Modifications to improve surface spacing irregularity in cases
  with proximity spacing reduction.

* Modified slightly farfield spacing calculation.

* Reduced default farfield spacing growth factor from 1.5 to 1.3.

* Created separate UVMAP library for uv mapping generation from
  AFLR4 and UG2 library routines.

* Update to EGADS 1.18.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 05/14/20 RELEASE VERSION 10.4.4
===============================================================

Enhancements/ Additions:
------------------------

* Added Grid BC check.

* Added modifications to insure that the minimum number of segments
  on a curve or loop set by min_nseg and min_nseg_loop is not
  limited my the minimum spacing set with min_scale and ref_len.

* Added a new input parameter std_ids to set the Grid BC to
  standard surface (STD_UG3_GBC) for IDs specified.

* Added the missing input parameter BC_IDs & Grid_BCs to set
  the grid BC to values specified for the surfaces specified.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 05/07/20 RELEASE VERSION 10.3.8
===============================================================

Enhancements/ Additions:
------------------------

* Modified u,v mapping used for scaling and singularity removal
  in CAD geometry definitions and eliminated internal parameters
  and limits. The primary process however did not change.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 04/23/20 RELEASE VERSION 10.2.16
===============================================================

Enhancements/ Additions:
------------------------

* Changed u,v mapping modification to use reduced scaling with
  CAD definitions that have a bounding curve that includes a
  discontinuity (physical edge length is zero). Note that in
  these cases the u,v mapping is transformed into a triangle
  shaped or diamond shaped mapping from the original square
  mapping.

* Added capability to estimate the BL thickness based on Reynolds
  Number. A new AFLR4 parameter named Re_l was added to set Reynolds
  Number. A corresponding EGADS attribute named AFLR4_Re_l was
  also added.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 04/09/20 RELEASE VERSION 10.2.8
===============================================================

Enhancements/ Additions:
------------------------

* Modified process for determining farfield point spacing. The
  new process includes overall domain size, inner body size,
  reference length and field growth rate and results in improved
  determination of farfield spacing. The old parameter ff_nseg
  is no longer used or available. Instead, the primary user
  control on farfield spacing is a new parameter that controls
  the field spacing growth rate, ff_cdfr. The default value is
  1.2 and the farfield spacing varies linearly when the value
  of ff_cdfr is changed.

* Update to EGADS 1.17.

* Added parallel mode capability using a fork/shared-memory
  strategy.

* Modifications for surface based background mesh length scale
  interpolation.

* Added growth to UV grid generation when edge refinement is
  active to reduce number of faces generated in approximation
  grid.

* Changed parameter names for edge refinement. Previously the
  related parameters all were named msfe_all & sfe* and were labeled
  edge scale factor weight. They are now named mer_all * erw*
  and are labeled edge refinement weight.

* Changed u,v mapping modification to not use scaling with
  CAD definitions that have a bounding curve that includes a
  discontinuity (physical edge length is zero). Note that in
  these cases the u,v mapping is transformed into a triangle
  shaped or diamond shaped mapping from the original square
  mapping.

* Modified point insertion process for edges that are only
  attached to surface bounding curves.

* Added capability to add overall AFLR4 parameters to the EGADS
  data as attributes attached to the model.

* Added capability to add a rectangular or square box farfield
  geometry and add it to the EGADS data structure.

* Added capability to write new EGADS data file with attributes
  that may be new and/or farfield box that may be added.

Bugs Fixed:
-----------

* Corrected an issue in proximity checking for surfaces which
  connect to themselves in xyz physical space.

===============================================================
aflr4 RELEASE NOTES: 01/16/20 RELEASE VERSION 9.16.2
===============================================================

Enhancements/ Additions:
------------------------

* Added quad-tree based searching to surface based length scale
  evaluation.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 10/26/19 RELEASE VERSION 9.17.1
===============================================================

Enhancements/ Additions:
------------------------

* Modifications for surface based length scale background grid
  evaluation from volume based.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 08/16/19 RELEASE VERSION 9.16.1
===============================================================

Enhancements/ Additions:
------------------------

* Added a global surface mesh spacing factor parameter, sf_all.
  This parameter provides the capability to globally scale all
  surface mesh spacing.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/30/19 RELEASE VERSION 9.15.1
===============================================================

Enhancements/ Additions:
------------------------

* Added a lower and upper limit to uv values for evaluation of
  curvature on EGADS/OpenCASCADE surface definitions. This is
  to compensate for an issue in the underlying derivatives from
  OpenCASCADE that EGADS uses to calculate curvature. For some
  surface definitions there is a singularity in the derivative
  that causes erroneous curvature values at the uv boundaries
  of the surface definition. The input parameter uv_curv_lim
  provides a limit on how close to the actual boundary curvature
  can be evaluated (uv_curv_lim < uv < 1-uv_curv_lim). Discrete
  surface definitions are unchanged.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/09/19 RELEASE VERSION 9.14.11
===============================================================

Enhancements/ Additions:
------------------------

* Added new capability for generation and output of surface mesh
  quality using routine ug3_qchkb.

* Changes for compatibility with revised lib DGEOM.

* Modified initial edge grid generation process for improved
  efficiency.

* The EGADS version of AFLR4 now uses EGADS Version 1.15 and
  OpenCASCADE Version 7.3.1.

* Modified process to add and glue component surfaces within a 
  composite surface definition. These modifications improve
  efficiency of the process significantly without altering the
  result.

* Changed parameter check_tess_ordering to check_tess.

* Added parameter cad_param_reset to reset all EGADS Attributes
  to default values for AFLR4.

* Modified CAD surface definition mapping transformation for
  definitions with a singular point and an opposing near singular
  region (similar to a double singular football shaping mapping).
  The modified form improves the resulting surface mesh for
  these cases.

Bugs Fixed:
-----------

* Corrected evaluation issue that produced coordinates on curves
  that were offset from the actual surface definition.

===============================================================
aflr4 RELEASE NOTES: 05/08/19 RELEASE VERSION 9.13.5
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for high-order evaluation of discrete geometry.

* Modified internal eigenvector analysis for curvature and
  high-order evaluation of discrete geometry.

* Modified setting of default components for proximity.

* Added input parameter options, cmp_ids and cmp_list, for setting
  of components for proximity based on surface ID.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 02/26/19 RELEASE VERSION 9.11.6
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for gluing non-manifold connections with
  discrete geometry definitions.

* Removed restriction that did not allow automatic scaling of
  surface edge mesh spacing based on discontinuity level between
  adjacent surfaces on both sides of the edge.

* Improved uv-map generation for cases with interior curves.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 02/07/19 RELEASE VERSION 9.11.3
===============================================================

Enhancements/ Additions:
------------------------

* Added capability for gluing non-manifold connections with both
  discrete and CAD geometry definitions. Note that additional
  changes are required with discrete geometries.

* Changed all face neighbor map creation calls to the full 3D
  routine that allows for non-manifold multiply connected
  surfaces.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 01/28/19 RELEASE VERSION 9.10.11
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with modified EGADS_AFLR4 that now
  uses EGADS bodies as the data source instead of an EGADS model.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 12/11/18 RELEASE VERSION 9.9.11
===============================================================

Enhancements/ Additions:
------------------------

* Added edge mesh spacing scale factor for each surface. This
  allows the spacing on edges of a given surface to be modified
  based on the level of discontinuity between neighboring surfaces
  that share an edge.

* Added global edge mesh spacing scale factor option.

* Made edge mesh spacing scale modified spacing based on log
  interpolation.

* Changes for compatibility with EGADS_AFLR4 LIB.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 11/10/18 RELEASE VERSION 9.8.13
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with new surf_auto and surf_auto_cpp
  libs (which include all of previous dcurv, egen_auto and surfgen
  libs). 

* Changes for compatibility with new C-code API of surf_auto_cpp
  and ug_cpp libs.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 11/04/18 RELEASE VERSION 9.8.10
===============================================================

Enhancements/ Additions:
------------------------

* Added check if EGADS_INCLUDE_DIR is set and if it includes the
  EGADS system include files then that directory is used instead
  of egads_include. NOTE: This check is included in both
  egads_aflr4.compile_lib and aflr4/aflr4.compile.

* Added routine aflr4_cad_geom_file_cleanup to free all CAD geometry
  file related array space and close any open files.

* Changes for compatibility with revised DCURV, EGEN_AUTO, and
  SURFGEN libs.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 10/26/18 RELEASE VERSION 9.8.8
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to specify a mesh size scaling factor on each
  surface definition.

* Added option to create an add-on farfield using add_ff_geom.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 10/18/18 RELEASE VERSION 9.7.4
===============================================================

Enhancements/ Additions:
------------------------

* Added removal of BL intersecting surfaces within the back-ground
  grid to improve proximity checking.

* Added check for surfaces with projected uv-mapping set (planar
  surfaces) that do not have far-field or BL-intersecting grid
  BCs. If found the ug-mapping is set back to free-boundary
  uv-mapping. This process is activated only during proximity
  checking.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 10/05/18 RELEASE VERSION 9.6.7
===============================================================

Enhancements/ Additions:
------------------------

* Added support of multiple-bodies within EGADS models.

* Improved handling of degenerate CAD edges.

* Added transparent surface capability.

Bugs Fixed:
-----------

* Fixed a potential surface spacing value mismatch.

===============================================================
aflr4 RELEASE NOTES: 09/25/18 RELEASE VERSION 9.5.6
===============================================================

Enhancements/ Additions:
------------------------

* Added auto-generation of edge and surface grids with curvature
  dependent spacing.

Bugs Fixed:
-----------

===============================================================
aflr4 RELEASE NOTES: 08/15/18 RELEASE VERSION 9.3.3
===============================================================

Enhancements/ Additions:
------------------------

* Added auto-generation of edge and surface grids.

* Modified use of growth rate to prevent limiting in compression.

Bugs Fixed:
-----------


===============================================================
aflr4 RELEASE NOTES: 12/06/17 RELEASE VERSION 8.19.1
===============================================================

Enhancements/ Additions:
------------------------

* Added general process for setting length scale data using
  an interpolation process with a background grid (or similar).
  This process now includes the boundary edge grid data.

Bugs Fixed:
-----------


===============================================================
aflr4 RELEASE NOTES: 08/07/17 RELEASE VERSION 8.17.51
===============================================================

Enhancements/ Additions:
------------------------

* Added external/extra CAD geometry data to the geometry definition
  data structure for passing to external CAD evaluation routines.
  Note that the API for all external `functions defined by the
  aflr4_register_cad_geom_* functions were modified to accommodate
  this change.

Bugs Fixed:
-----------


===============================================================
aflr4 RELEASE NOTES: 06/13/17 RELEASE VERSION 8.16.47
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with 64-bit integers.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 12/17/16 RELEASE VERSION 8.15.42
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised libraries.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/31/16 RELEASE VERSION 8.15.34
===============================================================

Enhancements/ Additions:
------------------------

* Added an option, -disp, to create and output a glue-only mesh
  that is reduced for graphical display. routine aflr4_get_def.

* Modified the default boundary edge spacing set in EGADS.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 05/18/16 RELEASE VERSION 8.13.31
===============================================================

Enhancements/ Additions:
------------------------

* Added a no quad face option to routine aflr4_get_def.

Bugs Fixed:
-----------

* Corrected an issue writing final surface grid file.

===============================================================
aflr4 RELEASE NOTES: 04/04/16 RELEASE VERSION 8.12.28
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with new version of egen.

* Added normal spacing argument for use with AFLR3.

* Changes for compatibility with new version of AFLR2C.

* Added compatibility with AFLR2C metric normal spacing specification
  that is compatible with AFLR3 metric BL blending.

* Combined AFLR4 Lib and AFLR4_API Lib. AFLR4_API Lib is no
  longer separate or used.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/30/15 RELEASE VERSION 8.2.4
===============================================================

Enhancements/ Additions:
------------------------

* Added integration with the Engineering Geometry Aircraft Design
  System (EGADS) from MIT and Open CASCADE from Open CASCADE S.A.S.
  for CAD functionality. Both are licensed under The GNU Lesser
  General Public License, version 2.1 and are freely available.
  See aflr4_cad_geom.c for more information.

* Added capability to import a full CAD model compatible with the
  above and generate a surface mesh suitable for AFLR3 volume grid
  generation. With the current system the AFLR4 executable is
  now suitable as is for complete surface generation.

* Modified calling sequence and routines library aflr4_api. Most
  APIs have changed and any code that integrates AFLR4 will
  require modification to be compatible with the current API.

* See aflr4 -h or aflr4 -help for information on command line
  options.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 03/31/15 RELEASE VERSION 7.3.29
===============================================================

Enhancements/ Additions:
------------------------

* Reduced mapping generation output slightly.

* Modified internal API for surface search (ug3_srchbf) to allow
  for a two-pass algorithm that uses a large tolerance on the
  second pass to find locations that are off the surface and near
  a surface node.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 07/06/14 RELEASE VERSION 7.2.18
===============================================================

Enhancements/ Additions:
------------------------

* Updated API for initialization of external sizing function in
  DFTR3 library. This required an internal API change for
  routine g4fgen. The external API for all aflr4_* routines is
  unchanged.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 06/26/14 RELEASE VERSION 7.1.18
===============================================================

Enhancements/ Additions:
------------------------

* Change include for REC3_API_LIB to REC3_LIB.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 06/26/14 RELEASE VERSION 7.1.17
===============================================================

Enhancements/ Additions:
------------------------

* Updated API for initialization of external sizing function in
  DFTR3 library. This required an internal API change for
  routine g4fgen. The external API for all aflr4_* routines is
  unchanged.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 06/03/14 RELEASE VERSION 7.1.15
===============================================================

Enhancements/ Additions:
------------------------

* Convert to new ug parameter structure scheme and eliminate
  use of Error_Message.

Bugs Fixed:
-----------

* 

===============================================================
aflr4 RELEASE NOTES: 10/20/13 RELEASE VERSION 6.10.27
===============================================================

Enhancements/ Additions:
------------------------

* Updated character string declarations.

Bugs Fixed:
-----------

* 

Known Issues
------------


===============================================================
aflr4 RELEASE NOTES: 01/30/13 RELEASE VERSION 6.10.24
===============================================================

Enhancements/ Additions:
------------------------

* Updated API for changes related to mappings based on projecting
  to a plane.

Bugs Fixed:
-----------

* 

Known Issues
------------


===============================================================
aflr4 RELEASE NOTES: 01/11/13 RELEASE VERSION 6.11.24
===============================================================

Enhancements/ Additions:
------------------------

* Updated CMake files.

Bugs Fixed:
-----------

* 

Known Issues
------------

